(use-modules (guix packages)
             (guix git-download)
             (guix build-system ruby)
             (gnu packages ruby)
             (gnu packages databases)
             (gnu packages rails)
             (gnu packages terraform)
             (gnu packages python)
             (gds packages govuk ruby))

(define govuk-mini-environment-admin
  (package
    (name "govuk-mini-environment-admin")
    (version "0")
    (source #f)
    (build-system ruby-build-system)
    (inputs
     `(("ruby-rails" ,ruby-rails)
       ("ruby-pg" ,ruby-pg)
       ("ruby-gds-sso" ,ruby-gds-sso)
       ("ruby-govuk-admin-template" ,ruby-govuk-admin-template)
       ("ruby-plek" ,ruby-plek)
       ("ruby-terraform"
        ,(package
           (inherit ruby-terraform)
           (arguments
            '(#:phases
              (modify-phases %standard-phases
                (replace 'replace-git-ls-files
                  (lambda _
                    (substitute* "ruby_terraform.gemspec"
                      (("`git ls-files -z`") "`find . -type f -print0`")))))))
           (source
            (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/cbaines/ruby_terraform.git")
                    ;; hash for the support-passing-target-to-destroy branch
                    (commit "b858f9d7b1a5c193b94bd4bf38eea5fc3afd0295")))
              (sha256
               (base32
                "0714zhc0rak2wrb2yivy7a1naqlcccwgd90lp2vpjs7aj3j23i2k"))))))
       ("ruby-que" ,ruby-que)
       ("ruby-with-advisory-lock" ,ruby-with-advisory-lock)
       ("ruby-git" ,ruby-git)
       ("terraform" ,terraform)
       ("terraform-provider-libvirt"
        ,(package
           (inherit terraform-provider-libvirt)
           (source
            (origin
              (method git-fetch)
              (uri (git-reference
                    (url "http://git.cbaines.net/terraform-provider-libvirt")
                    ;; hash for the for-govuk-mini-environment-admin branch
                    (commit "682f8a9865fe0bec16423f63018725f5b364659b")))
              (sha256
               (base32
                "1wxiyfkmvflf6c669h6i9ym21r5w4mw55jiy6gma3cddlbhpjhhb"))))))
       ("terraform-provider-template" ,terraform-provider-template)
       ("terraform-provider-aws" ,terraform-provider-aws)
       ("terraform-provider-local" ,terraform-provider-local)))
    (native-inputs
     `(("ruby-rubocop" ,ruby-rubocop)
       ("python" ,python)
       ("ruby-mocha" ,ruby-mocha)
       ("coala" ,coala)
       ("coala-bears" ,coala-bears)))
    (synopsis "")
    (description "")
    (home-page "")
    (license "")))

(define govuk-mini-environment-admin-development-environment
  (package
    (inherit govuk-mini-environment-admin)
    (inputs
     `(,@(package-inputs govuk-mini-environment-admin)
       ("ruby" ,ruby)
       ("ruby-rerun" ,ruby-rerun)
       ("ruby-annotate" ,ruby-annotate)
       ;; Useful for debugging and required for using Robe (Emacs)
       ("ruby-byebug" ,ruby-byebug)
       ("ruby-web-console", ruby-web-console)
       ("postgresql" ,postgresql)))))

govuk-mini-environment-admin-development-environment
